<id>
Debug Plus
</id>

<version>
v1
</version>

<mod info>
Adds extra debug process and CPU usage infos ....

- Performed file in this process
- Process number of ongoing process
- Process start time
- Perl Interpreter of process
- Perl Version
- CPU usage (not working on all server)
- Average server load -> 01 minutes, 05 minutes and 15 minutes ago  (not working on all server)

... and fix also a small HTML tag issue in the debug print (not closed "<span>" tag in class="under")

</mod info>

<author>
XTC
</author>

<homepage>
http://www.xonder.com/cgi-bin/yabb26/YaBB.pl
</homepage>

<edit file>
Sources/Debug.pm
</edit file>

<search for>
        $yydebug =
qq~<br /><div class="small debug"><span class="under">$debug_txt{'debugging'}<span><br /><br /><span class="under">$debug_txt{'benchmarking'}:</span><br />$yytimeclock<br /><br /><span class="under">$debug_txt{'ipaddress'}:</span><br />$user_ip<br /><br /><span class="under">$debug_txt{'browser'}:</span><br />$ENV{'HTTP_USER_AGENT'}<br />$getpairs<br /><span class="under">$debug_txt{'trace'}:</span>$yytrace<br /><br /><span class="under">$debug_txt{'check'}:</span><br />$yyfileactions<br /><br /><span class="under">$debug_txt{'filehandles'}:</span><br />$debug_txt{'filehandleslegend'}<br /><br />$openfiles<br /><span class="under">$debug_txt{'filesloaded'}:<span class="tt">require</span></span>~;
</search for>

<replace>
        if(-e("/proc/stat")){
            open(F,"</proc/stat");
            $cputemp = <F>;
            close(F);

            ($cpuname,$cpuuser,$cpuwert,$cpusystem,$cpuidle) = split(/\s+/,$cputemp);
            $cpuusage = $cpuuser + $cpuwert + $cpusystem;
            $cputotal = $cpuuser + $cpuwert + $cpusystem + $cpuidle;

            sleep(1);

            open(F,"</proc/stat");
            $cputemp = <F>;
            close(F);

            ($newName, $newUser, $newWert, $newSystem, $newIdle) = split(/\s+/,$cputemp);
            $newUsage = $newUser + $newWert + $newSystem;
            $newTotal = $newUser + $newWert + $newSystem + $newIdle;

            $xUsage = $newUsage - $cpuusage;
            $xTotal = $newTotal - $cputotal;

		if($xTotal > 1 or $xUsage > 1){
			$cpulast = sprintf("%.1f", (($xUsage / $xTotal) * 100));
		}
            $cpulast .= q{%};
        }else{
            $cpulast = "$debug_txt{'supported'}";
        }

        $cpload = `uptime`; # Alternative: /proc/loadavg and /proc/uptime

        if($cpload =~ /^.+?average: +?(\S*? \S*? \S*?)$/){
  			($load1, $load5, $load15) = split(',',$1,4);
            $load1 .= q{%};
            $load5 .= q{%};
            $load15 .= q{%};
        }else{
            $load1 = "$debug_txt{'supported'}";
            $load5 = "$debug_txt{'supported'}";
            $load15 = "$debug_txt{'supported'}";
        }

        $pidtime = timeformat( $BASETIME, 1 );

        $yydebug =
qq~<br /><div class="small debug"><span class="under"><b>$debug_txt{'process_scalars'}</b></span><br /><br /><span class="under">$debug_txt{'process_file'}:</span><br />$PROGRAM_NAME<br /><br /><span class="under">$debug_txt{'process_num'}:</span><br />PID: $PID<br /><br /><span class="under">$debug_txt{'process_time'}:</span><br />$BASETIME ($pidtime)<br /><br /><span class="under">$debug_txt{'process_interpreter'}:</span><br />$EXECUTABLE_NAME<br /><br /><span class="under">$debug_txt{'perl_version'}:</span><br />$PERL_VERSION<br /><br /><span class="under">$debug_txt{'server_load'}:</span><br />$cpulast<br /><br /><span class="under">$debug_txt{'server_load_ago'}:</span><br />01 $debug_txt{'minute'}: $load1<br />05 $debug_txt{'minute'}: $load5<br />15 $debug_txt{'minute'}: $load15<br />~;

        $yydebug .=
qq~<br /><span class="under"><b>$debug_txt{'debugging'}</b></span><br /><br /><span class="under">$debug_txt{'benchmarking'}:</span><br />$yytimeclock<br /><br /><span class="under">$debug_txt{'ipaddress'}:</span><br />$user_ip<br /><br /><span class="under">$debug_txt{'browser'}:</span><br />$ENV{'HTTP_USER_AGENT'}<br />$getpairs<br /><span class="under">$debug_txt{'trace'}:</span>$yytrace<br /><br /><span class="under">$debug_txt{'check'}:</span><br />$yyfileactions<br /><br /><span class="under">$debug_txt{'filehandles'}:</span><br />$debug_txt{'filehandleslegend'}<br /><br />$openfiles<br /><span class="under">$debug_txt{'filesloaded'}:<span class="tt">require</span></span>~;
</replace>

<edit file>
Languages/English/Debug.lng
</edit file>

<search for>
'filesloaded' => 'Files loaded by',
</search for>

<add after>
'process_scalars' => 'Process scalars',
'process_num' => 'Process number of this ongoing process',
'process_file' => 'Performed file in this process',
'process_time' => 'Process start time',
'process_interpreter' => 'Interpreter of this process',
'perl_version' => 'Perl Version',
'server_load' => 'CPU usage',
'server_load_ago' => 'Average server load ago',
'minute' => 'minutes',
'supported' => 'Not supported',
</add after>